#ASSEMBLADOR EduP12

import sys
from string import join
import os
from eduP12Dic import *

print "\tASSEMBLADOR EduP12.v1"
print "\t Joan Oliver"
print "\t Agost 2011\n"

#Llegir fitxer
#Crea una llista del codi d'entrada amb un primer tractament
def lect_fitxer(debug):
    print "\t1. Lectura fitxer..."
    if debug:
        print ' '*12, '--Debugging ', '-'*42
    nom=raw_input("\t\tFitxer d'entrada... ")
    E = []
    prog1=[]
    linia=0
    if os.path.exists(nom):
        f_in = open(nom, 'r')
        for line in f_in:
            if debug: print ' '*12, 'Linia ', linia, ' -> ', line
            instr=[]
            nova = []
            #Adequar linies per tractament posterior d'instruccions
            s = [line]                           #trobar linies
            s = [j.lower().replace('\n','').replace('\t',' ').replace('=',' ').replace(',',' ') for j in s]
            s = [j.replace(':',': ').replace('z +','z+').replace('y +','y+').replace('x +','x+') for j in s]
            s = [j.split() for j in s]          #elimina espais redundants  
            for j in range(len(s)):
                s[j] = join(s[j], sep=' ')
            #Deixar signes indispensables i sense espais
            s = [j.lower().replace(' :',':').replace('- ','-').replace('+ ','+') for j in s]
            nova.append(linia)
            linia = linia+1
            if s!=['']:
                if (';' not in s[0]) or (s[0].index(';')==0) or (': ;' in s[0]):
                    nova.append('c')
                    nova.append(s[0][:(len(s[0])-1)])
                elif (':' in s[0]) and (s[0].index(':')<s[0].index(';')):
                    if ('.' in s[0]) and (s[0].index('.')<s[0].index(':')):
                        E.append('Etiqueta no correcta, linia '+str(linia-1)+'-> '+s[0])
                    elif s[0].index(' ')<s[0].index(':'):
                        E.append('Etiqueta no correcta, linia '+str(linia-1)+'-> '+s[0])
                    else:
                        nova.append('e')
                        nova.append(s[0][:(len(s[0])-1)])
                else:
                    nova.append('i')
                    nova.append(s[0][:(len(s[0])-1)])
                prog1.append(nova)              #Instruccio
        f_in.close()
    else:
        E.append('Error en lectura de fitxer. Existeix?')
    cars='0123456789abcdefghijklmnopqrstuvwxyz+-.: '
    for instr in prog1:
        if debug: print ' '*12, 'Instruccio: ', instr
        if instr[1]=='i' or instr[1]=='e':
            s = instr[2]
            if ';' in s:
                s = s[:(s.index(';'))]
            valid=True
            for c in s:
                if c not in cars:
                    valid = False
            if not valid:
                E.append('Caracters rars en linia '+str(instr[0])+'-> '+s)
    return nom, prog1, E

def pre_analisis(prog1, debug):
    print "\t2. Pre-analisis instruccions..."
    if debug: print ' '*12, '--Debug: etiquetes i directives ', '-'*23
    E = []
    W = []
    kons = {}
    defs = {}
    etis = {}
    prog2 = []
    linia = 0
    pict = {}
    for instr in prog1:
        nou=[]
        if instr[1]=='i' or instr[1]=='e':  #per totes instruccions correctes
            if ';' in instr[2]:
                l = instr[2][:instr[2].index(';')]
            else:
                l = instr[2]
            l = l.split()
            if instr[1]=='e':               #treure etiquetes
                etiqueta = l[0][:(len(l[0])-1)]
                k=siNum(etiqueta)
                if siNum(etiqueta)=='nn':
                    etis[etiqueta]=linia
                    l = l[1:]
                    if debug: print ' '*12, 'Etiqueta->   ', etiqueta, l
                else:
                    E.append('Etiqueta no correcta, linia'+str(l[0])+'-> '+instr[2])
            if '.' in l[0]:
                if l[0]=='.org':
                    #Origen ha de ser numeric, no pot ser una constant
                    if debug: print  ' '*12, 'Directiva->  ', l
                    if len(l)!=2:
                        E.append('Origen incorrecte, linia '+str(instr[0])+'-> '+instr[2])
                    else:
                        c = siNum(l[1])
                        #if c=='nn':
                        #    E.append('Origen incorrecte, linia '+str(instr[0])+'-> '+instr[2])
                        #else:
                        #    if (c<0) or (c>nMaxRam):
                        #        W.append("Es correcte l'origen? Linia "+str(instr[0])+'-> '+instr[2])
                        #    linia = c
                        if c=='nn':
                            if kons.has_key(l[1]):
                                c=kons[l[1]]
                            else:
                                E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                        if (c<0) or (c>nMaxRam):
                            W.append("Es correcte l'origen? Linia "+str(instr[0])+'-> '+instr[2])
                        linia = c
                elif l[0]=='.con':
                    #Constant ha de ser numerica, no pot ser altra constant
                    if debug: print  ' '*12, 'Directiva->  ', l
                    if len(l)!=3:
                        E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+instr[2])
                    else:
                        c = siNum(l[1])
                        n = siNum(l[2])
                        if (c!='nn') or (n=='nn'):
                            E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+instr[2])
                        else:
                            if kons.has_key(l[1]):
                                W.append('Constant reassignada, linia '+str(instr[0])+'-> '+instr[2])
                            kons[l[1]] = n
                elif l[0]=='.def':
                    if debug: print  ' '*12, 'Directiva->  ', l
                    if len(l)!=3:
                        E.append('Nomenament incorrecte, linia '+str(instr[0])+'-> '+instr[2])
                    else:
                        n = siNum(l[1])
                        m = siReg(l[1])
                        r = siReg(l[2])
                        if (n!='nn') or (m!='nn') or (r=='nn'):
                            E.append('Nomenament incorrecte, linia '+str(instr[0])+'-> '+instr[2])
                        else:
                            if defs.has_key(l[1]):
                                W.append('Nomenament reassignat, linia '+str(instr[0])+'-> '+instr[2])
                            defs[l[1]] = r
                elif l[0]=='.dw':
                    #Tota constant emprada ha de ser previament definida
                    pict[linia] = instr[2]
                    if debug: print  ' '*12, 'Directiva->  ', l
                    if len(l)<2:
                        E.append('Llistat incorrecte, linia '+str(instr[0])+'-> '+instr[2])
                    else:
                        nou.append(linia)
                        nou.append(l[0])
                        for i in range(1, len(l)):
                            n = siNum(l[i])
                            if (n=='nn'):
                                if kons.has_key(l[i]):
                                    nou.append(kons[l[i]])
                                else:
                                    E.append('Numero incorrecte, linia '+str(instr[0])+'-> '+instr[2])
                            else:
                                nou.append(n)
                                linia=linia+1
                    prog2.append(nou)
                else:
                    E.append('...quina directiva?, linia '+str(instr[0])+'-> '+instr[2])
            else:
                pict[linia] = instr[2]
                if debug: print  ' '*12, 'Instruccio-> ', l
                if l[0] in instruccio:
                    clau = tipInstr[l[0]]
                    nou.append(linia)
                    nou.append(clau)
                    nou.append(l)
                    prog2.append(nou)
                    if (clau==2) or (clau==22): linia=linia+2
                    else: linia=linia+1
                else:
                    E.append('Instruccio no existeix, linia '+str(instr[0])+'-> '+instr[2])
        elif instr[1] != 'c':
            E.append('...quina instruccio es? Linia'+str(instr[0])+'-> '+instr[2])
    #Comprovacio de no repeticio de noms
    for i in kons:
        if i in defs: E.append('Constant reassignada en nomenaments: '+i)
        if i in etis: E.append('Constant reassignada en etiquetes: '+i)
    for i in defs:
        if i in etis: E.append('Nomenament repetit en etiquetes: '+i)
    return prog2, pict, kons, defs, etis, E, W

def analisis_instruccions(prog2, kons, defs, etis, debug):
    print "\t3. Analisis instruccions: linia codi, instruccio"
    if debug: print ' '*12, '--Debug: analisis ', '-'*23
    E = []
    W = []
    prog3 = []
    for instr in prog2:
        nou = []
        if instr[1]=='.dw':
            if debug: print ' '*12, 'Linia ', instr[0], ' -> .dw'
            nou.append(instr[0])
            nou.append(100)
            for i in instr[2:]:
                nou.append(i)
            prog3.append(nou)
        else:
            if debug: print ' '*12, 'Linia ', instr[0], ' -> ', instr[2]
            tipus = instr[1]
            nCamps = len(instr[2])-1
            codiInstr = unioLlista(instr[2])
            nou.append(instr[0])
            nou.append(instr[1])
            nou.append(instr[2][0])
            if tipus==0:
                if nCamps!=0:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+codiInstr)
                else:
                    prog3.append(nou)
            elif (tipus==1):
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = siReg(instr[2][1])
                    if c1=='nn':
                        if defs.has_key(instr[2][1]):
                            c1=defs[instr[2][1]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    c2 = siReg(instr[2][2])
                    if c2=='nn':
                        if defs.has_key(instr[2][2]):
                            c2=defs[instr[2][2]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c2)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif (tipus==2):
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = siReg(instr[2][1])
                    if c1=='nn':
                        if defs.has_key(instr[2][1]):
                            c1=defs[instr[2][1]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    c2 = siNum(instr[2][2])
                    if c2=='nn':
                        if kons.has_key(instr[2][2]):
                            c2=kons[instr[2][2]]
                        elif etis.has_key(instr[2][2]):
                            c2=etis[instr[2][2]]
                        else:
                            E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c2)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==22:
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = siNum(instr[2][1])
                    if c1=='nn':
                        if kons.has_key(instr[2][1]):
                            c1=kons[instr[2][1]]
                        elif etis.has_key(instr[2][1]):
                            c1=etis[instr[2][1]]
                        else:
                            E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    c2 = siReg(instr[2][2])
                    if c2=='nn':
                        if defs.has_key(instr[2][2]):
                            c2=defs[instr[2][2]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c2)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif (tipus==3) or (tipus==13):
                if nCamps!=1:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = siReg(instr[2][1])
                    if c1=='nn':
                        if defs.has_key(instr[2][1]):
                            c1=defs[instr[2][1]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif (tipus==4):
                if nCamps!=1:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    linAct = instr[0]
                    c1 = siNum(instr[2][1])
                    if c1=='nn':
                        if etis.has_key(instr[2][1]):
                            c1=etis[instr[2][1]]
                        else:
                            E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                            c1 = 0
                    nou.append(c1-(linAct+1))
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==5:
                #Exigeix index's x, y o z
                if nCamps!=1:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = instr[2][1]
                    if (c1=='z') or (c1=='y') or (c1=='x'):
                        nou.append(regsClone[c1])
                    else:
                        E.append("Camp no es 'x', 'y' o 'z', linia "+str(instr[0])+'-> '+codiInstr)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==6:
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    if instr[2][0]=='in':
                        c1 = siReg(instr[2][1])
                        if c1=='nn':
                            if defs.has_key(instr[2][1]):
                                c1=defs[instr[2][1]]
                            else:
                                E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                        c2 = instr[2][2]
                        if ports.has_key(c2):
                            c2 = ports[c2]
                        else:
                            E.append('Port incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    else:   #'out'
                        c1 = instr[2][1]
                        if ports.has_key(c1):
                            c1 = ports[c1]
                        else:
                            E.append('Port incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                        c2 = siReg(instr[2][2])
                        if c2=='nn':
                            if defs.has_key(instr[2][2]):
                                c2=defs[instr[2][2]]
                            else:
                                E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    nou.append(c2)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif (tipus==7) or (tipus==77):
                if ((nCamps!=1)and(tipus==7)) or ((nCamps!=2)and(tipus==77)):
                     E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    linAct = instr[0]
                    c1 = siNum(instr[2][1])
                    if c1=='nn':
                        if etis.has_key(instr[2][1]):
                            c1=etis[instr[2][1]]
                        else:
                            E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                            c1 = 0
                    nou.append(c1-(linAct+1))
                    if tipus==77:
                        c2 = siNum(instr[2][2])
                        if c2=='nn':
                            if etis.has_key(instr[2][2]):
                                c2=etis[instr[2][2]]
                            else:
                                E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                    else:
                        c2 = 0
                    nou.append(c2)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==8:
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = siReg(instr[2][1])
                    if c1=='nn':
                        if defs.has_key(instr[2][1]):
                            c1=defs[instr[2][1]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    c2 = instr[2][2]
                    if regsClone.has_key(c2):
                        nou.append(regsClone[c2])
                    else:
                        E.append("Camp no es 'x', 'y' o 'z', linia "+str(instr[0])+'-> '+codiInstr)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==9:
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = siReg(instr[2][1])
                    if c1=='nn':
                        if defs.has_key(instr[2][1]):
                            c1=defs[instr[2][1]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    c2 = (instr[2][2]).split('+')
                    c20 = c2[0]
                    if c20=='z': nou.append('0')
                    elif c20=='y': nou.append('1')
                    else:
                        E.append("Registre no es 'y+' o 'z+', linia "+str(instr[0])+'-> '+codiInstr)
                    if len(c2)>2:
                        E.append("Camp no correcte, linia "+str(instr[0])+'-> '+codiInstr)
                    elif len(c2)==2:
                        c21=siNum(c2[1])
                        if c21=='nn':
                            if etis.has_key(c2[1]):
                                c21=etis[c2[1]]
                            if kons.has_key(c2[1]):
                                c21=kons[c2[1]]
                            else:
                                E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                        if c21<0:
                            E.append("La constant no pot ser negativa, linia "+str(instr[0])+'-> '+codiInstr)
                    else:
                        c21 = 0
                    nou.append(c21)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==10:
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = instr[2][1]
                    if regsClone.has_key(c1):
                        nou.append(regsClone[c1])
                    else:
                        E.append("Registre no es 'x', 'y' o 'z', linia "+str(instr[0])+'-> '+codiInstr)
                    c2 = siReg(instr[2][2])
                    if c2=='nn':
                        if defs.has_key(instr[2][2]):
                            c2=defs[instr[2][2]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c2)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==11:
                if nCamps!=2:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = (instr[2][1]).split('+')
                    if len(c1)==0 or len(c1)>2:
                        E.append("Numero de camps incorrecte, linia "+str(instr[0])+'-> '+codiInstr)
                    c10 = c1[0]
                    if c10=='z': nou.append('0')
                    elif c10=='y': nou.append('1')
                    else:
                        E.append("Registre no es 'y+' o 'z+', linia "+str(instr[0])+'-> '+codiInstr)
                    if len(c1)==2:
                        c11=siNum(c1[1])
                        if c11=='nn':
                            if kons.has_key(c1[1]):
                                c11=kons[c1[1]]
                            elif etis.has_key(c1[1]):
                                c11=etis[c1[1]]
                            else:
                                E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                        if c11<0:
                            E.append("La constant no pot ser negativa, linia "+str(instr[0])+'-> '+codiInstr)
                    else:
                        c11 = 0
                    nou.append(c11)
                    c2 = siReg(instr[2][2])
                    if c2=='nn':
                        if defs.has_key(instr[2][2]):
                            c2=defs[instr[2][2]]
                        else:
                            E.append('Registre incorrecte, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c2)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            elif tipus==12:
                if nCamps!=1:
                    E.append('Numero incorrecte de camps, linia '+str(instr[0])+'-> '+ codiInstr)
                else:
                    c1 = siNum(instr[2][1])
                    if c1=='nn':
                        if kons.has_key(instr[2][1]):
                            c1=kons[instr[2][1]]
                        else:
                            E.append('Constant incorrecta, linia '+str(instr[0])+'-> '+codiInstr)
                    nou.append(c1)
                    prog3.append(nou)
                    if debug: print ' '*28, nou
            else:
                E.append('Quina instruccio es? Linia '+str(instr[0])+'-> '+ codiInstr)
    return prog3, E, W

def codificar(prog3, debug):
    print "\t4. Codificacio..."
    if debug: print ' '*12, '--Debug: codificant ', '-'*23
    E = []
    W = []
    prog4 = []
    for instr in prog3:
        linia = instr[0]
        if debug: print ' '*12, linia, '->', instr[2:]
        if (linia<0) or (linia>nMaxRam): W.append('Numero 0<=k<nMaxRam de linia incorrecte'+str(linia))
        tipus=instr[1]
        if tipus==100:
            for i in instr[2:]:
                nou = []
                nou.append(linia)
                if (i<-2**11) or (i>2**11): W.append('Numero -2^11<k<2^11 no representable, linia '+str(linia)+'-> '+ str(i))
                codi = '0000'+dec2bin(i,2**12)
                nou.append(codi)
                prog4.append(nou)
                linia = linia+1
                if debug: print ' '*20, codi
        else:
            nou = []
            base = instruccio[instr[2]]
            nou.append(linia)
            if tipus==0:
                nou.append(base)
                prog4.append(nou)
                if debug: print ' '*20, base
            elif (tipus==1) or (tipus==3) or (tipus==13):
                rd = dec2bin(instr[3],2**5)
                if tipus==3:
                    codi = base[:7]+rd+base[12:]
                else:
                    if tipus==1:
                        rs = dec2bin(instr[4],2**5)
                    else:
                        rs = rd;
                    codi = base[:6]+rs[0]+rd+rs[1:]
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            elif (tipus==2) or (tipus==22):
                if tipus==2:
                    rd = dec2bin(instr[3],2**5)
                    k = instr[4]
                else:
                    rd = dec2bin(instr[4],2**5)
                    k = instr[3]
                codi = base[:7]+rd+base[12:]
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
                nou = []
                if abs(k>(2**12-1)):
                    W.append('Numero |k|>(2^12-1) no representable, linia '+str(linia)+'-> '+ str(k))
                codi = dec2bin(k,2**16)
                nou.append(linia+1)
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            elif (tipus==4) or (tipus==12):
                k = instr[3]
                if tipus==4:
                    if abs(k>(2**12-1)):
                        W.append('Numero |k|>(2^12-1) no representable, linia '+str(linia)+'-> '+ str(k))
                    codi = base[:4]+dec2bin(k,2**12)
                else:
                    if abs(k>7):
                        W.append('Numero |k|>7 no representable, linia '+str(linia)+'-> '+ str(k1))
                    codi = base[:13]+dec2bin(k,8)
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            elif (tipus==5):
                codi = base[:4]+instr[3][:3]+base[7:]
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            elif (tipus==6):
                if instr[2]=='in':
                    rd = dec2bin(instr[3],2**5)
                    k = instr[4]
                else:
                    rd = dec2bin(instr[4],2**5)
                    k = instr[3]
                codi = base[:5]+k[:2]+rd+k[2:]
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            elif (tipus==7) or (tipus==77):
                k1 = instr[3]
                if abs(k1>(2**8-1)):
                    W.append('Numero |k|>(2^8-1) no representable, linia '+str(linia)+'-> '+ str(k1))
                sk1=dec2bin(k1,2**9)
                if tipus==77:
                    k2 = instr[4]
                    if abs(k2>7):
                        W.append('Numero |k|>7 no representable, linia '+str(linia)+'-> '+ str(k2))
                    sk2=dec2bin(k2,8)
                else:
                    sk2 = base[13:]
                codi = base[:4]+sk1+sk2
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            elif (tipus==8) or (tipus==10):
                if tipus==8:
                    rd = dec2bin(instr[3],2**5)
                    codi = base[:4]+instr[4][:3]+rd+base[12:14]+instr[4][3:]
                else:
                    rd = dec2bin(instr[4],2**5)
                    codi = base[:4]+instr[3][:3]+rd+base[12:14]+instr[3][3:]
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            elif (tipus==9) or (tipus==11):
                if tipus==9:
                    rd = dec2bin(instr[3],2**5)
                    r = instr[4]
                    k = instr[5]
                else:
                    rd = dec2bin(instr[5],2**5)
                    r = instr[3]
                    k = instr[4]
                if abs(k>(2**7-1)):
                    W.append('Numero k>(2^7-1) no representable, linia '+str(linia)+'-> '+ str(k))
                sk=dec2bin(k,2**7)
                codi = base[:2]+r+base[3]+sk[:3]+rd+sk[3:]
                nou.append(codi)
                prog4.append(nou)
                if debug: print ' '*20, codi
            else:
                E.append('Quina instruccio es? Linia '+str(instr[0]))
    return prog4, E, W


#Impressio VHD...
def codiVHD(nom, prog4, pict, debug):
    print '\t5. Codi VHDL ...'
    W = []
    prog5 = []
    for instr in prog4:
        if debug: print ' '*12, instr
        if pict.has_key(instr[0]):
            comment = pict[instr[0]]
        else:
            comment = ''
        codhex = '%X' % bin2dec(instr[1])
        prog5.append('('+str(instr[0])+', "'+instr[1]+'"), -- 0x'+codhex +' - '+comment)

    #Comprovacio de no solapament d'instruccions
    for i in range(len(prog5)):
	for j in range(i+1,len(prog5)):
            s1=eval(prog5[i][1:(prog5[i].index(','))])
            s2=eval(prog5[j][1:(prog5[j].index(','))])
            if s1==s2:
                W.append('Origen repetit, linia '+str(s1)+':\n\t\t 1-> '+
                         prog5[i][:(prog5[i].find(' - '))]+'\n\t\t 2-> '+prog5[j][:(prog5[j].find(' - '))])

    #Fitxer de sortida
    f_out = open((nom.split('.')[0]+'.vhd'), 'w')
    iniciCapsal=1
    for j in capsal:
        if 'NOM_PROGRAMA' in j:
            string = j.replace('NOM_PROGRAMA', nom.split('.')[0])
            f_out.write(string)
        else:
            f_out.write(j)
    lin = 0
    for instr in prog5:
        actual = eval(instr[1:(instr.index(','))])
        if lin!= actual: f_out.write('--\n')
        lin = actual+1
        f_out.write(instr+'\n')
    
    for j in final:
        f_out.write(j)
    f_out.close();
    return prog5, W

#Impressio Bin...
def codiBin(nom, prog4, pict, debug):
    prog6 = []
    if imprimirBin:
        print "No implementat..."
        print "S'ha de personalitzar segons .bin..."
    return prog6

def ajuda():
    print "AJUDA D'ASSEMBLADOR EDUP12"
    print "(Joan Oliver. Agost'11)"
    print "\t -h -> ajuda"
    print "\t -d -> treure resultats conforme processa"
    print "\t -l -> llistar resultats intermitjos"
    print "\t -nv -> no fitxer .vhd (per defecte activat)"
    print "\t -b -> fitxer .bin (s'ha de personalitzar)"

def main():
    #Variables generals
    inici = True
    debug = False
    llistar = False
    imprimirVhd = True
    imprimirBin = False

    for arg in sys.argv[1:]:
        if arg=='-h':
            ajuda()
            inici = False
        elif arg=='-d': debug = True
        elif arg=='-l': llistar = True
        elif arg=='-nv': imprimirVhd=False
        elif arg=='-b': imprimirBin=True

    if inici:
        nom, prog1, E = lect_fitxer(debug)
        if len(E)!=0:
            for i in E: print '\t...ERROR: ', i
        else:
            prog2, pict, kons, defs, etis, E, W = pre_analisis(prog1, debug)
            del prog1
            if len(W)!=0:
                for i in W: print '\t...WARNING: ', i
            if len(E)!=0:
                for i in E: print '\t...ERROR: ', i
            else:
                if llistar==True:
                    print ' '*10, '.'*50
                    print ' '*10, 'CONSTANTS '
                    for i in kons: print ' '*13, i,' = ', kons[i]
                    print ' '*10, 'DEFINICIONS '
                    for i in defs: print ' '*13, i,' = ', defs[i]
                    print ' '*10, 'ETIQUETES '
                    for i in etis: print ' '*13, i,' = ', etis[i]
                    print ' '*10, '.'*50
                    print ' '*10, 'INSTRUCCIONS '
                    print ' '*13, '[Linia, Clau, Instruccio]'
                    for i in prog2: print  ' '*13, i
                prog3, E, W = analisis_instruccions(prog2, kons, defs, etis, debug)
                del prog2
                del kons
                del defs
                del etis
                if len(W)!=0:
                    for i in W: print '\t...WARNING: ', i
                if len(E)!=0:
                    for i in E: print '\t...ERROR: ', i
                else:
                    if llistar==True:
                        print ' '*10, 'INSTRUCCIONS I CAMPS '
                        print ' '*13, '[Linia, Clau, Instruccio]'
                        for i in prog3: print  ' '*13, i
                    prog4, E, W = codificar(prog3, debug)
                    del prog3
                    if len(W)!=0:
                        for i in W: print '\t...WARNING: ', i
                    if len(E)!=0:
                        for i in E: print '\t...ERROR: ', i
                    else:
                        if llistar==True:
                            print ' '*10, 'INSTRUCCIONS I CAMPS '
                            print ' '*13, 'Linia, Codi'
                            for i in prog4: print  ' '*13, i
                        if imprimirVhd==True:
                            prog5, W = codiVHD(nom, prog4, pict, debug)
                            if len(W)!=0:
                                for i in W: print '\t...WARNING: ', i
                            print ' '*10, 'Instruccions assemblador en codi VHDL '
                            for i in prog5: print  ' '*13, i
                            del prog5
                        if imprimirBin==True:
                            prog6 = codiBin(nom, prog4, pict, debug)
                            print ' '*10, 'Instruccions assemblador en codi VHDL '
                            for i in prog5: print  ' '*13, i
                            del prog6
                        del prog4
                        del pict
    print '\n\t Fi proces...'
        
if __name__ == "__main__":
    main()
