
-- PROGRAMA COMUNICACI AMB PC
--	TxD sense interrupci, RxD amb interrupci
-- Adreces inicials: interrupcions
.org 0;
	RJMP main;	     	->a main
	RJMP isrExt0dw ;	->a 512
	RJMP isrExt0up ;	->a 576
	RJMP isrExt1dw ;	->a 640
	RJMP isrExt1up ;	->a 704
	RJMP isrExt2dw ;	->a 768
	RJMP isrExt2up ;	->a 832
	RJMP isrExt3dw ;	->a 896
	RJMP isrExt3up ;	->a 960
	RJMP isrTim0Ovrf ;	->a 1024
	RJMP isrTim0CmpA ;	->a 1088
	RJMP isrTim0CmpB ; 	->a 1152
	RJMP isrFtoc1 ;		->a 1216
	RJMP isrFtoc0 ;		->a 1280
	RJMP isrTxD ;		->a 1344
	RJMP isrRxD ;		->a 1408
	RJMP error ;		->a 1472

--Programa principal
.org 32;
main:	RCALL iniciSS;
	LDI R16, 4;
	OUT ext0ctrl, R16;	--Activaci interrupci externa 1 down
	LDI R16, 0x010C;		--Control usart: interrupci RxD, presc=12 (115200bauds-24MHz)
	OUT uart0ctrl, R16;
	SEI ;			--Activaci interrupts
retorn: RJMP retorn;
	NOP;

iniciSS:LDI X, hex2ss0;
	LPM R16, X;
	OUT SS0, R16;
	OUT SS1, R16;
	OUT SS2, R16;
	OUT SS3, R16;
	RET;
	NOP;
--Rutina d'interrupci Ext0-0-down
.org 512;
isrExt0dw: LDI X, hex2ss1;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Ext0-0-up
.org 576;
isrExt0up: LDI X, hex2ss2;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Ext0-1-down
.org 640;
isrExt1dw: IN X, PORTA	;		--Agafar slides
	OUT uart0txd, X	;		--Enviar a TxD
	RETI;
	NOP;

--Rutina d'interrupci Ext0-1-up
.org 704;
isrExt1up: LDI X, hex2ss4;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Ext0-2-down
.org 768;
isrExt2dw: LDI X, hex2ss5;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Ext0-2-up
.org 832;
isrExt2up: LDI X, hex2ss6;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Ext0-3-down
.org 896;
isrExt3dw: LDI X, hex2ss7;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Ext0-3-up
.org 960;
isrExt3up: LDI X, hex2ss8;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Timer0 Overflow
.org 1024;
isrTim0Ovrf: LDI X, hex2ss9;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Timer0 Comparador A
.org 1088;
isrTim0CmpA: LDI X, hex2ss10;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci Timer0 Comparador B
.org 1152;
isrTim0CmpB: LDI X, hex2ss11;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci ftoc1
.org 1216;
isrFtoc1: LDI X, hex2ss12;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci ftoc0
.org 1280;
isrFtoc0: LDI X, hex2ss13;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci de transmissi
.org 1344;
isrTxD: LDI X, hex2ss14;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

--Rutina d'interrupci de recepci
.org 1408;
isrRxD: IN X, uart0rxd;		--rebre
	OUT PORTB, X;		--enviar a leds
	RETI;
	NOP;
	
--Rutina d'interrupci d'error
.org 1472;
error: LDI X, hex2ss16;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

.org 1600;
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x6;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x7;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ss10: .dw 0x5F;
hex2ss11: .dw 0x7C;
hex2ss12: .dw 0x58;
hex2ss13: .dw 0x5E;
hex2ss14: .dw 0x79;
hex2ss15: .dw 0x71;
hex2ss16: .dw 0x80;
